﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window 
    {
        CollectionView cv;
        public MainWindow()
        {
            InitializeComponent();
            cv = new CollectionView(TreeData.GenerateTreeData());
            this.DataContext = cv;
        }

        private void TextBox_TextChanged(object sender, TextChangedEventArgs e)
        {
            cv.Filter = item =>
            {
                TreeData vitem = item as TreeData;
                if (vitem == null) return false;

                return vitem.Name.ToLower().Contains((sender as TextBox).Text.ToLower());
            };
        }
    }

    public class TreeData : INotifyPropertyChanged 

{
    private int id;

    public int ID
    {
        get { return id; }
        set { id = value; }
    }

    private bool _isVisible = true;
    public bool IsVisible
    {
        get { return _isVisible; }
        set
        {
            _isVisible = value;
            this.OnPropertyChagned("IsVisible");
        }
    }


    private string name;

    public string Name
    {
        get { return name; }
        set { name = value; }
    }

    private ObservableCollection<TreeData> children;

    public ObservableCollection<TreeData> Children
    {
        get { return children; }
        set { children = value; }
    }

    public static ObservableCollection<TreeData> GenerateTreeData()
    {
        ObservableCollection<TreeData> data = new ObservableCollection<TreeData>();

        for (int i = 0; i < 10; i++)
        {
            TreeData n = new TreeData
                {
                    ID = i,
                    Name = "Item " + i,
                    Children = new ObservableCollection<TreeData>()
                };

            for (int j = 0; j < 5; j++)
            {
                TreeData n1 = new TreeData
                    {
                        ID = i + j,
                        Name = "Item " + i + " " + j,
                        Children = new ObservableCollection<TreeData>()
                    };

                for (int p = 0; p < 5; p++)
                {
                    n1.children.Add(new TreeData
                        {
                            ID = i + j + p,
                            Name = "Item " + i + " " + j + " " + p,
                        });
                }

                n.Children.Add(n1);
            }

            data.Add(n);
        }

        return data;
    }


    public event PropertyChangedEventHandler PropertyChanged;

    public void OnPropertyChagned(string name)
    {
        if (PropertyChanged != null)
            PropertyChanged(this, new PropertyChangedEventArgs(name));
    }
}
}
